#include <iostream>
#include <GL/glew.h>
#include <GLFW/glfw3.h>

#include "rendering/GLFW.h"

struct GLFWInit final {
    bool error;

    GLFWInit() : error(glfwInit() == GLFW_FALSE) {
        if(error) {
            std::cout << "could not initialize GLFW\n";
        }
    }

    ~GLFWInit() {
        glfwTerminate();
    }
};

static GLFWInit init;

bool GLFW::hasError() {
    return init.error;
}

u64 GLFW::getTimeNanos() {
    return glfwGetTimerValue() * (1000000000 / glfwGetTimerFrequency());
}