#ifndef WINDOW_H
#define WINDOW_H

#include <GL/glew.h>
#include <GLFW/glfw3.h>

class Window final {
public:
    Window(int width, int height, const char* windowName);
    ~Window();
    Window(const Window&) = delete;
    Window& operator=(const Window&) = delete;
    Window(Window&&) = delete;
    Window& operator=(Window&&) = delete;

    bool hasError() const;
    void show();
    bool shouldClose() const;
    void swapBuffers();

    void setFramebufferSizeCallback(GLFWframebuffersizefun f);
    void setKeyCallback(GLFWkeyfun f);

private:
    GLFWwindow* window;
};

#endif